unit Unit1;

// 3DStudio file viewer (c)2001 by Paul TOTH <tothpaul@free.fr>

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, FileCtrl, StdCtrls, WinGL, ExtCtrls, DelphiGL, GLRender;

type
  TForm1 = class(TForm)
    WinGL1: TWinGL;
    FileListBox1: TFileListBox;
    DirectoryListBox1: TDirectoryListBox;
    DriveComboBox1: TDriveComboBox;
    FilterComboBox1: TFilterComboBox;
    Memo1: TMemo;
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    procedure FileListBox1DblClick(Sender: TObject);
    procedure WinGL1Paint(Sender: TObject);
    procedure WinGL1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure WinGL1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure WinGL1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    mm,mx,my:integer;
    rx,ry,rz:single;
    tz:single;
    procedure OnLog(s:string);
  public
    { Public declarations }
    obj:TGLObject;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FileListBox1DblClick(Sender: TObject);
begin
{$ifdef log}
 Memo1.Lines.BeginUpdate;
 Memo1.Lines.Clear;
{$endif}
 obj.Load3DS(FileListBox1.FileName);
{$ifdef log}
 Memo1.Lines.EndUpdate;
{$endif}
 obj.Normalise;
 rx:=0;
 ry:=0;
 rz:=0;
 tz:=-2;
 WinGL1.Invalidate;
end;

procedure TForm1.WinGL1Paint(Sender: TObject);
begin
 obj.Rotate(rx,ry,rz);
 glTranslatef(0,0,tz);
 obj.Render;
end;

procedure TForm1.WinGL1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 mm:=ord(Button)+1;
 mx:=x;
 my:=y;
end;

procedure TForm1.WinGL1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 mm:=0;
end;

procedure TForm1.WinGL1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
 case mm of
  0: exit;
  1: begin
   rx:=rx+(y-my);
   ry:=ry+(x-mx);
   WinGL1.Invalidate;
  end;
  2: begin
   tz:=tz+(my-y)/100;
   WinGL1.Invalidate;
  end;
 end;
 mx:=x;
 my:=y;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 obj:=TGLObject.Create;
{$ifdef log}
 Log:=OnLog;
{$endif}
end;

procedure TForm1.OnLog(s:string);
 begin
  memo1.lines.Add(s);
 end;

end.
